<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;

use Doctrine\ORM\EntityRepository;

class Organization extends EntityRepository {

    public function getOrganization($id = null, $name = null) {
        $query = <<<SQL
            SELECT O.ID ,O.NAME, TO_CHAR(O.FOUNDATION, 'DD/MM/YYYY') AS FOUNDATION, O.DESCRIPTION, O.DOCUMENT,
            LISTAGG(P.RESOURCE_T, ',') WITHIN GROUP (ORDER BY P.RESOURCE_T) AS MANAGERS,D.ID AS CALENDAR_DEFAULT,
            D.NAME AS BASE_CALENDAR,C.ID AS CALENDAR,S.ID AS STRUCTURE,S.TIME_SHEET_REQUIRED
            FROM ORGANIZATION O
            LEFT JOIN STRUCTURE S ON (O.ID = S.ORGANIZATION AND S.PARENT IS NULL)
            LEFT JOIN PERMISSION P ON(P.STRUCTURE = S.ID AND P.TYPE = 'M')
            LEFT JOIN CALENDAR C ON (C.ID = S.CALENDAR)
            LEFT JOIN CALENDAR D ON (D.ID = C.CALENDAR_DEFAULT)
            WHERE O.STATUS <> 'D'
SQL;
        
        if(!empty($id)){
            $query .= <<<SQL
                AND O.ID = :id
SQL;
        }
        
        if(!empty($name)){
            $query .= <<<SQL
                AND O.NAME = :name
SQL;
        }
        $query.=<<<SQL
 GROUP BY O.ID ,O.NAME, O.FOUNDATION, O.DESCRIPTION, O.DOCUMENT,D.ID,D.NAME,C.ID,S.ID,S.TIME_SHEET_REQUIRED
SQL;

        $param = array(
            'id' => $id,
            'name' => $name
        );

        $organizations = $this->getEntityManager()->getConnection()->fetchAll($query, $param);
        foreach($organizations as &$organization){
            $organization['MANAGERS'] = explode(',', $organization['MANAGERS']);
        }
        return $organizations;
    }

}